// Generated by purs version 0.15.9
import * as $foreign from "./foreign.js";
import * as Data_Maybe from "../Data.Maybe/index.js";
import * as Data_Nullable from "../Data.Nullable/index.js";
import * as Data_Semiring from "../Data.Semiring/index.js";
import * as Node_FS_Constants from "../Node.FS.Constants/index.js";
import * as Node_FS_Perms from "../Node.FS.Perms/index.js";
var readWrite = /* #__PURE__ */ (function () {
    var rw = Data_Semiring.add(Node_FS_Perms.semiringPerm)(Node_FS_Perms.read)(Node_FS_Perms.write);
    return Node_FS_Perms.mkPerms(rw)(rw)(rw);
})();
var $$null = /* #__PURE__ */ (function () {
    return Data_Nullable.toNullable(Data_Maybe.Nothing.value);
})();
var nonnull = function ($2) {
    return Data_Nullable.toNullable(Data_Maybe.Just.create($2));
};
var fdCreateWriteStreamWith = function (opts) {
    return function (fd) {
        return function () {
            return $foreign.createWriteStreamImpl($$null, {
                fd: fd,
                mode: Node_FS_Perms.permsToInt(opts.perms),
                flags: Node_FS_Constants.fileFlagsToNode(opts.flags)
            });
        };
    };
};
var fdCreateReadStreamWith = function (opts) {
    return function (fd) {
        return function () {
            return $foreign.createReadStreamImpl($$null, {
                fd: fd,
                mode: Node_FS_Perms.permsToInt(opts.perms),
                flags: Node_FS_Constants.fileFlagsToNode(opts.flags),
                autoClose: opts.autoClose
            });
        };
    };
};
var defaultWriteStreamOptions = /* #__PURE__ */ (function () {
    return {
        flags: Node_FS_Constants.W.value,
        perms: readWrite
    };
})();
var fdCreateWriteStream = /* #__PURE__ */ fdCreateWriteStreamWith(defaultWriteStreamOptions);
var defaultReadStreamOptions = /* #__PURE__ */ (function () {
    return {
        flags: Node_FS_Constants.R.value,
        perms: readWrite,
        autoClose: true
    };
})();
var fdCreateReadStream = /* #__PURE__ */ fdCreateReadStreamWith(defaultReadStreamOptions);
var createWriteStreamWith = function (opts) {
    return function (file) {
        return function () {
            return $foreign.createWriteStreamImpl(nonnull(file), {
                mode: Node_FS_Perms.permsToInt(opts.perms),
                flags: Node_FS_Constants.fileFlagsToNode(opts.flags)
            });
        };
    };
};
var createWriteStream = /* #__PURE__ */ createWriteStreamWith(defaultWriteStreamOptions);
var createReadStreamWith = function (opts) {
    return function (file) {
        return function () {
            return $foreign.createReadStreamImpl(nonnull(file), {
                mode: Node_FS_Perms.permsToInt(opts.perms),
                flags: Node_FS_Constants.fileFlagsToNode(opts.flags),
                autoClose: opts.autoClose
            });
        };
    };
};
var createReadStream = /* #__PURE__ */ createReadStreamWith(defaultReadStreamOptions);
export {
    createWriteStream,
    fdCreateWriteStream,
    defaultWriteStreamOptions,
    createWriteStreamWith,
    fdCreateWriteStreamWith,
    createReadStream,
    fdCreateReadStream,
    defaultReadStreamOptions,
    createReadStreamWith,
    fdCreateReadStreamWith
};
